//---------------------------------------------------------------------------
#include <vcl.h>
#include <Registry.hpp>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
#include "ifmmedia.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

extern ifmmVar ifmmvar;
//---------------------------------------------------------------------------
#ifdef SetDlgH
__fastcall TDialogForm::TDialogForm(HWND ParentWindow)
    : TSetDlgForm(ParentWindow)
#else
__fastcall TDialogForm::TDialogForm(TComponent* Owner)
    : TForm(Owner)
#endif
{
    //Jɕʂ̂ƂANeBuɂĂ邩Ȃ̂
    ifmmPC->ActivePage = PlayerTS;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::CancelBClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::OKBClick(TObject *Sender)
{
    //ݒۑ
    var.option[IFMMOPT_MemoryPlay] = MemPlayCB->Checked;
    var.option[IFMMOPT_ReturnErr]  = RetErrCB->Checked;
    var.option[IFMMOPT_StayOnTop]  = StayOnTopCB->Checked;
    var.option[IFMMOPT_NoActive]   = NoActiveCB->Checked;
    var.option[IFMMOPT_WindowPos]  = WindowPosCB->Checked;
    var.option[IFMMOPT_WindowPosX] = X;
    var.option[IFMMOPT_WindowPosY] = Y;

    if ( (MovieH != 0) && (MovieW != 0) ) {
        var.option[IFMMOPT_MoviePosX]   = MX;
        var.option[IFMMOPT_MoviePosY]   = MY;
        var.option[IFMMOPT_MovieHeight] = MovieH;
        var.option[IFMMOPT_MovieWidth]  = MovieW;
    }

    var.option[IFMMOPT_PreviewMovie] = PreviewCB->Checked;
    var.option[IFMMOPT_PreviewPos1] = PrePosEdit1->Text.ToIntDef(0);
    var.option[IFMMOPT_PreviewPos2] = PrePosEdit2->Text.ToIntDef(5);
    var.option[IFMMOPT_Minimized]    = MinimizedCB->Checked;
    var.option[IFMMOPT_MovieSize]    = SizeRG->ItemIndex;
    var.option[IFMMOPT_MovieCenter]  = CenterCB->Checked;

    var.option[IFMMOPT_SusieOnly] = SusieOnlyCB->Checked;
    var.option[IFMMOPT_PlayByViX] = PlayByViXCB->Checked;
    var.option[IFMMOPT_DebugMode] = DebugCB->Checked;

    for (int i=0; i < FT_COUNT; i++) {
        var.playable[i] = SupportedCLB->Checked[i];
    }

    //܂Ƃ߂Set
    ifmmvar.Setallvar(&var);

    //WXgɕۑ
    bool ret;
    TRegistry *Reg = new TRegistry;
    //Reg->RootKey = HKEY_CURRENT_USER;
    ret = Reg->OpenKey("\\Software\\shimitei\\ifmm", true);
if (ret) {
    Reg->WriteBool("Memory",    var.option[IFMMOPT_MemoryPlay]);
    Reg->WriteBool("Error",     var.option[IFMMOPT_ReturnErr]);
    Reg->WriteBool("StayOnTop", var.option[IFMMOPT_StayOnTop]);
    Reg->WriteBool("NoActive",  var.option[IFMMOPT_NoActive]);
    Reg->WriteBool("WindowPos", var.option[IFMMOPT_WindowPos]);
    Reg->WriteInteger("WindowPosX", var.option[IFMMOPT_WindowPosX]);
    Reg->WriteInteger("WindowPosY", var.option[IFMMOPT_WindowPosY]);

if (MovieH != 0 && MovieW != 0) {
    Reg->WriteInteger("MoviePosX", var.option[IFMMOPT_MoviePosX]);
    Reg->WriteInteger("MoviePosY", var.option[IFMMOPT_MoviePosY]);
    Reg->WriteInteger("MovieHeight", var.option[IFMMOPT_MovieHeight]);
    Reg->WriteInteger("MovieWidth",  var.option[IFMMOPT_MovieWidth]);
}

    Reg->WriteBool("PreviewMovieFrame", var.option[IFMMOPT_PreviewMovie]);
    Reg->WriteInteger("PreviewPos1", var.option[IFMMOPT_PreviewPos1]);
    Reg->WriteInteger("PreviewPos2", var.option[IFMMOPT_PreviewPos2]);
    Reg->WriteBool("Minimized", var.option[IFMMOPT_Minimized]);
    Reg->WriteInteger("MovieSize", var.option[IFMMOPT_MovieSize]);
    Reg->WriteBool("MovieCenter", var.option[IFMMOPT_MovieCenter]);

    Reg->WriteBool("SusieOnly", var.option[IFMMOPT_SusieOnly]);
    Reg->WriteBool("PlayByViX", var.option[IFMMOPT_PlayByViX]);
    Reg->WriteBool("Debug", var.option[IFMMOPT_DebugMode]);

    Reg->WriteBool("WAVE", var.playable[WAVEPLAY]);
    Reg->WriteBool("MIDI", var.playable[MIDIPLAY]);
    Reg->WriteBool("AVI",  var.playable[AVIPLAY]);
    Reg->WriteBool("AIFF", var.playable[AIFFPLAY]);
    Reg->WriteBool("MOV",  var.playable[MOVPLAY]);
    Reg->WriteBool("MPEG", var.playable[MPEGPLAY]);
    Reg->WriteBool("MPA",  var.playable[MPAPLAY]);
    Reg->WriteBool("AU",   var.playable[AUPLAY]);
    Reg->WriteBool("WMA",  var.playable[WMAPLAY]);
    Reg->WriteBool("WMV",  var.playable[WMVPLAY]);
    Reg->WriteBool("ASF",  var.playable[ASFPLAY]);
    Reg->WriteBool("OGG",  var.playable[OGGPLAY]);
    Reg->WriteBool("RM",   var.playable[RMPLAY]);
    Reg->CloseKey();

} else {
    ShowMessage("WXgG[!\nݒۑł܂B");
}
    delete Reg;

    Close();
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::WindowPosBClick(TObject *Sender)
{
    //ijv[[EBhEʒu
    TPlayForm* PlayForm = new TPlayForm(this);

    PlayForm->Left = 0;
    PlayForm->Top  = 0;

    PlayForm->ShowModal();

    X = PlayForm->Left;
    Y = PlayForm->Top;

    delete PlayForm;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::L1DblClick(TObject *Sender)
{
    Tag++;
    if (Tag > 5) {
        //BIvVo
        DebugCB->Visible = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::L1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if (Shift.Contains(ssShift) && Shift.Contains(ssRight)) {
        //BIvVݒ\
        DebugCB->Enabled = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::CustomBClick(TObject *Sender)
{
    //ijv[[EBhEʒuTCY
    TPlayForm* PlayForm = new TPlayForm(this);

    PlayForm->PopupMenu = NULL;
    PlayForm->ScrollBox->OnClick = NULL;
    PlayForm->OnResize = PlayForm->FormResizeEx;
    PlayForm->BorderStyle = bsSizeable;

#define DEFAULT_WIDTH 260
    PlayForm->ClientHeight += Screen->DesktopHeight * 2 / 3 +2;
    PlayForm->ClientWidth  += Screen->DesktopWidth  * 2 / 3 +2 - DEFAULT_WIDTH ;
    PlayForm->Top    = (Screen->DesktopHeight -PlayForm->Height) /2;
    PlayForm->Left   = (Screen->DesktopWidth -PlayForm->Width) /2;

    PlayForm->ShowModal();

    MX = PlayForm->Left;
    MY = PlayForm->Top;
    MovieH = PlayForm->MovieP->Height -2;
    MovieW = PlayForm->MovieP->Width  -2;

    delete PlayForm;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::FormInit(void)
{
//Ń_CAȌs
//ݒɃ`FbNꂽƂ
    ifmmvar.Getallvar(&var);
    X = var.option[IFMMOPT_WindowPosX];
    Y = var.option[IFMMOPT_WindowPosY];

    MemPlayCB->Checked   = var.option[IFMMOPT_MemoryPlay];
    RetErrCB->Checked    = var.option[IFMMOPT_ReturnErr];
    StayOnTopCB->Checked = var.option[IFMMOPT_StayOnTop];
    NoActiveCB->Checked  = var.option[IFMMOPT_NoActive];
    WindowPosCB->Checked = var.option[IFMMOPT_WindowPos];

    PreviewCB->Checked   = var.option[IFMMOPT_PreviewMovie];
    PrePosEdit1->Text    = var.option[IFMMOPT_PreviewPos1];
    PrePosEdit2->Text    = var.option[IFMMOPT_PreviewPos2];
    MinimizedCB->Checked = var.option[IFMMOPT_Minimized];
    SizeRG->ItemIndex    = var.option[IFMMOPT_MovieSize];
    CenterCB->Checked    = var.option[IFMMOPT_MovieCenter];

    SusieOnlyCB->Checked = var.option[IFMMOPT_SusieOnly];
    PlayByViXCB->Checked = var.option[IFMMOPT_PlayByViX];
    DebugCB->Checked     = var.option[IFMMOPT_DebugMode];

    for (int i=0; i < FT_COUNT; i++) {
        SupportedCLB->Checked[i] = var.playable[i];
    }

    TStringList* AppSL = new TStringList();
    GetSusieCompatiAppName(AppSL);
    AppLB->Items->AddStrings(AppSL);
    delete AppSL;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::AppAddButtonClick(TObject *Sender)
{
    //WXgɓo^
    TRegistry *Reg = new TRegistry;
    //Reg->RootKey = HKEY_CURRENT_USER;
    bool ret = Reg->OpenKey("\\Software\\shimitei\\ifmm\\SusieCompati", true);
    //AppSL->Clear();
if (ret) {
    AnsiString dataname = AppEdit->Text;
    if (dataname != "") {
        Reg->WriteInteger(dataname, 0);
        AppLB->Items->Add(dataname);
        AppEdit->Text = "";
    }
} else {
    ShowMessage("WXgI[vG[I");
}
    delete Reg;
}
//---------------------------------------------------------------------------
void __fastcall TDialogForm::AppDelButtonClick(TObject *Sender)
{
    int index = AppLB->ItemIndex;
    if (index == -1) return;

    //WXg폜
    TRegistry *Reg = new TRegistry;
    //Reg->RootKey = HKEY_CURRENT_USER;
    bool ret = Reg->OpenKey("\\Software\\shimitei\\ifmm\\SusieCompati", false);
if (ret) {
    if (Reg->DeleteValue(AppLB->Items->Strings[index])) {
        AppLB->Items->Delete(index);
    } else {
        //ShowMessage("폜ɎsI");
    }
} else {
    ShowMessage("WXgI[vG[I");
}
    delete Reg;
}
//---------------------------------------------------------------------------


